# -*- coding: utf-8 -*-
#*******************************************************************
# JĂ镡̊\zvOQlɂč쐬܂@ *
#   water_level_prediction of a river by LSTM   ver.14 9/11        *
#  copyright  M. Kogoshi & S. Kogoshi                              *
#  ŎgpACAĔzz                         @           *
#  ÂƂɂĐӔC͈ؕ܂            @*
#  @@@@@@@@@@@@@@@@@@@@@@@@@@@@        *
#  model@\ǉ                                                   *
#  eXgpf[^zeniba_test.csvɕύX                         *
#  ̓f[^ύXzeniba_train0701_0803                           *
#  dropoutǉ                                                     *
#  \0.5Ԗ̃f[^5gp2Ԍ\@@ @@@@@  *
#*******************************************************************

#  Cu[̃C|[g
import keras
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from keras.models import Sequential
from keras.layers import Dense,  LSTM
from keras import metrics
from sklearn.preprocessing import MinMaxScaler
from sklearn.metrics import mean_squared_error

# trainf[^̊lƐl̒`
df = pd.read_csv('zeniba_train0701_0803.csv')
L = len(df)
dt = 10  # 10̃f[^
ft = 120 # 120̗\A60̗\̏ꍇ60ƂĂ
ift = int(ft/dt) 

#ۑmodel
savefile = "kamikawa.h5"

WL = np.array([df.iloc[:, 1]])
Rain = np.array([df.iloc[:, 2]])


Rain = Rain.reshape(-1, 1)  # sɕϊBiz̗vfs~1j
WL = WL.reshape(-1, 1)  # sɕϊBiz̗vfs~1j

Rain1 = Rain[2*ift-12:L-ift-12, :]  # \Ԃ4ԑÕf[^
WL1 = WL[2*ift-12:L-ift-12, :]  # \Ԃ4ԑÕf[^

Rain2 = Rain[2*ift-9:L-ift-9, :]  # \Ԃ3.5ԑÕf[^
WL2 = WL[2*ift-9:L-ift-9, :]  # \Ԃ3.5ԑÕf[^

Rain3 = Rain[2*ift-6:L-ift-6, :]  # \Ԃ3ԑÕf[^
WL3 = WL[2*ift-6:L-ift-6, :]  # \Ԃ3ԑÕf[^

Rain4 = Rain[2*ift-3:L-ift-3, :]  # \Ԃ2.5ԑÕf[^
WL4 = WL[2*ift-3:L-ift-3, :]  # \Ԃ2.5ԑÕf[^

Rain5 = Rain[2*ift:L-ift, :]  # \Ԃ2ԑÕf[^
WL5 = WL[2*ift:L-ift, :]  # \Ԃ2ԑÕf[^



# LSTMւ̓̓f[^쐬ƃ^[Qbgf[^
X = np.concatenate([WL1, Rain1,WL2, Rain2, WL3, Rain3,WL4, Rain4, WL5, Rain5], axis=1)
Y = WL[ift*3:L, :]  # ^[Qbgf[^

# f[^l̂̐`
scaler = MinMaxScaler()
scaler.fit(X)
X = scaler.transform(X)

scaler1 = MinMaxScaler()
scaler1.fit(Y)
Y = scaler1.transform(Y)

X = np.reshape(X, (X.shape[0], 1, X.shape[1]))
print(X.shape)


# ŏ1000Ԗڂ܂ł̃f[^wKɎgp
# f[^̔ԍzeniba_train0701_0803.csvƂ͂邱Ƃɒ
X_train = X[0:999, :, :]
Y_train = Y[0:999, :]

# AIf(LSTM)̍쐬
model = Sequential()
model.add(LSTM(100, activation='tanh',dropout=0.1, input_shape=(1, 10), recurrent_activation='hard_sigmoid'))
model.add(Dense(1))

model.compile(loss='mean_squared_error', optimizer='rmsprop', metrics=[metrics.mae])
model.fit(X_train, Y_train, epochs=20, batch_size=1, verbose=2)

#wKςmodel̕ۑ
model.save(savefile)

print("END")
